<?php

namespace App\Services;

use App\DTOs\PaymentDTO;
use App\Entities\Customer\ClientEntity;
use App\Entities\Customer\ServiceEntity;
use App\Entities\Equipment\ServerEntity;
use App\Entities\Equipment\ServerPartEntity;
use App\Entities\PaymentEntity;
use App\Forms\PaymentForm;
use App\Helpers\PaymentHelper;
use App\Models\PaymentModel;

use App\Services\Customer\Wallet\WalletService;
use DateTime;
use RuntimeException;

class PaymentService extends CommonService
{
    private $_form = null;
    private $_helper = null;
    public function __construct(PaymentModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('Payment');
    }
    public function getDTOClass(): string
    {
        return PaymentDTO::class;
    }
    public function getEntityClass(): string
    {
        return PaymentEntity::class;
    }
    public function createDTO(array $formDatas): PaymentDTO
    {
        return new PaymentDTO($formDatas);
    }
    public function getFormService(): PaymentForm
    {
        if ($this->_form === null) {
            $this->_form = new PaymentForm();
            $this->_form->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_form;
    }
    public function getHelper(): PaymentHelper
    {
        if ($this->_helper === null) {
            $this->_helper = new PaymentHelper();
            $this->_helper->setAttributes([
                'pk_field'         =>  $this->getPKField(),
                'title_field'      => $this->getTitleField(),
                'table'            => $this->model->getTable(),
                'useAutoIncrement' => $this->model->useAutoIncrement(),
                'class_path' => $this->getClassPaths(false)
            ]);
        }
        return $this->_helper;
    }
    //총 미납건수, 금액
    final public function getUnPaids(string $group, array $where = []): array
    {
        $builder = $this->model->groupBy($group)
            ->select("{$group},COUNT(uid) as cnt, SUM(amount) as amount")
            ->where(['status' => STATUS['UNPAID']])
            ->where($where)
            ->builder();
        // echo $builder->getCompiledSelect(false); //초기화 없이 SQL만 보고 싶을 때: getCompiledSelect(false) ← 꼭 false!            
        $unPaids = [];
        foreach ($builder->get()->getResult() as $row) {
            $unPaids[$row->$group] = ['cnt' => $row->cnt, 'amount' => $row->amount];
        }
        return $unPaids;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): PaymentEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    public function setFilter(string $field, mixed $filter_value): void
    {
        switch ($field) {
            case 'role':
                //FIND_IN_SET()은 MySQL 함수이므로 CodeIgniter가 이를 일반 컬럼명으로 착각하고 escape하게 되면 오류가 발생
                // 따라서 ->where($sql, null, false)로 명시하여 escape를 꺼줘야 정상 작동
                $where = "FIND_IN_SET(" . $this->model->escape($filter_value) . ", {$this->model->getTable()}.{$field}) > 0";
                $this->model->where($where, null, false);
                break;
            default:
                parent::setFilter($field, $filter_value);
                break;
        }
    }
    //검색어조건절처리
    public function setSearchWord(string $word): void
    {
        $this->model->orLike($this->model->getTable() . '.id', $word, 'both');
        $this->model->orLike($this->model->getTable() . '.email', $word, 'both');
        parent::setSearchWord($word);
    }
    //추가기능 
    //pay방식에따른 WalletService 등록
    private function getWalletService($pay): WalletService
    {
        $walletService = null;
        switch ($pay) {
            case PAYMENT['PAY']['ACCOUNT']:
                $walletService = service('customer_wallet_accountservice');
                break;
            case PAYMENT['PAY']['COUPON']:
                $walletService = service('customer_wallet_couponservice');
                break;
            case PAYMENT['PAY']['POINT']:
                $walletService = service('customer_wallet_pointservice');
                break;
            default:
                throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: {$pay}는 지정되지 않은 지불방식입니다.");
                // break;
        }
        return $walletService;
    }
    //일회성,선결제,쿠폰,포인트 입력 관련
    protected function create_process(array $formDatas): PaymentEntity
    {
        if (!array_key_exists('serviceinfo_uid', $formDatas)) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 서비스가 정의되지 않았습니다.");
        }
        $serviceEntity = service('customer_serviceservice')->getEntity($formDatas['serviceinfo_uid']);
        if (!$serviceEntity instanceof ServiceEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: {$formDatas['serviceinfo_uid']}에 해당하는 서비스정보를 찾을 수 없습니다.");
        }
        $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUid();
        $entity = parent::create_process($formDatas);
        if (!$entity instanceof PaymentEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생:Return Type은 PaymentEntity만 가능");
        }
        //지불이 완료된경우 지불처리
        if ($entity->getStatus() === STATUS['PAID']) {
            $this->getWalletService($entity->getPay())->withdrawalByPayment($entity);;
        }
        //선결제인경우 서비스정보에 결제일 변경용
        if ($entity->getBilling() === PAYMENT['BILLING']['PREPAYMENT']) {
            service('customer_serviceservice')->updateBillingAt($entity->getServiceInfoUid(), $entity->getBillingAt());
        }
        return $entity;
    }

    protected function modify_process($entity, array $formDatas): PaymentEntity
    {
        if ($entity->getStatus() === STATUS['PAID']) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 이미 지불된 결제정보는 수정이 불가합니다.");
        }
        if (!array_key_exists('serviceinfo_uid', $formDatas)) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 서비스가 정의되지 않았습니다.");
        }
        $serviceEntity = service('customer_serviceservice')->getEntity($formDatas['serviceinfo_uid']);
        if (!$serviceEntity instanceof ServiceEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: {$formDatas['serviceinfo_uid']}에 해당하는 서비스정보를 찾을 수 없습니다.");
        }
        $formDatas['clientinfo_uid'] = $serviceEntity->getClientInfoUid();
        //수정된 결제정보
        $entity = parent::modify_process($entity, $formDatas);
        if (!$entity instanceof PaymentEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생:Return Type은 PaymentEntity만 가능");
        }
        //지불이 된경우 지불처리
        if ($entity->getStatus() === STATUS['PAID']) {
            $this->getWalletService($entity->getPay())->withdrawalByPayment($entity);;
        }
        //선결제인경우 서비스정보에 결제일 변경용
        if ($entity->getBilling() === PAYMENT['BILLING']['PREPAYMENT']) {
            service('customer_serviceservice')->updateBillingAt($entity->getServiceInfoUid(), $entity->getBillingAt());
        }
        return $entity;
    }
    protected function delete_process($entity): PaymentEntity
    {
        if ($entity->getStatus() === STATUS['PAID']) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 이미 지불된 결제정보는 수정이 불가합니다.");
        }
        return parent::delete_process($entity);
    }

    //청구서 관련
    public function getInvoices(ClientEntity $clientEntity, ServiceEntity $serviceEntity, PaymentEntity $entity, array $rows): array
    {
        if (!array_key_exists($clientEntity->getPK(), $rows)) {
            $rows[$clientEntity->getPK()] = [
                'name'         => $clientEntity->getName(),
                'total_amount' => 0,
                'services'     => [],
            ];
        }
        if (!array_key_exists($serviceEntity->getPK(), $rows[$clientEntity->getPK()]['services'])) {
            $serverEntity = service('equipment_serverservice')->getEntity($serviceEntity->getServerInfoUid());
            if (!$serverEntity instanceof ServerEntity) {
                throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생:[{$serviceEntity->getServerInfoUid()}]에 대한 서버정보를 찾을 수 없습니다.");
            }
            $rows[$clientEntity->getPK()]['services'][$serviceEntity->getPK()] = [
                'ip'       => $serverEntity->getIP(),
                'billing_at' => $serviceEntity->getBillingAt(),
                'amount' =>  0,
                'items'      => [],
            ];
        }
        //entities에 총 결제금액 설정
        $rows[$clientEntity->getPK()]['services'][$serviceEntity->getPK()]['items'][] = [
            'title' => $entity->getTitle(),
            'amount' => $entity->getAmount()
        ];
        $rows[$clientEntity->getPK()]['services'][$serviceEntity->getPK()]['amount'] += $entity->getAmount();
        $rows[$clientEntity->getPK()]['total_amount'] += $entity->getAmount();
        return $rows;
    }

    //서비스관련
    private function getFormDatasFromService(ServiceEntity $serviceEntity, array $formDatas = []): array
    {
        $formDatas['serviceinfo_uid'] = $serviceEntity->getPK();
        $formDatas["clientinfo_uid"] = $serviceEntity->getClientInfoUid();
        $formDatas['amount']          = $serviceEntity->getAmount();
        $formDatas['billing']         = $formDatas['billing'] ?? PAYMENT['BILLING']['MONTH'];
        $formDatas['billing_at']      = $serviceEntity->getBillingAt();
        $formDatas['pay']             = $formDatas['pay'] ?? PAYMENT['PAY']['ACCOUNT'];
        $formDatas['status']          = $formDatas['status'] ?? STATUS['UNPAID'];
        $formDatas['title']         = sprintf(
            "%s %s 서비스비용",
            $formDatas['title'] ?? $serviceEntity->getTitle(),
            DateTime::createFromFormat('Y-m-d', $formDatas['billing_at'])->format('Y년 m월')
        );
        return $formDatas;
    }
    public function createByService(ServiceEntity $serviceEntity): PaymentEntity
    {
        $formDatas = $this->getFormDatasFromService($serviceEntity);
        return parent::create_process($formDatas);
    }
    public function modifyByService(ServiceEntity $oldServiceEntity, ServiceEntity $serviceEntity): PaymentEntity
    {
        //기존 서비스정보의 청구방식이 Month이고 지급기한일과 같고,상태가 UNPAID인 결제정보 가져와서 결제정보 수정
        $entity = $this->getEntity([
            'serviceinfo_uid' => $oldServiceEntity->getPK(),
            'billing' => PAYMENT['BILLING']['MONTH'],
            'billing_at' =>  $oldServiceEntity->getBillingAt(),
            'status' =>  STATUS['UNPAID']
        ]);
        if (!$entity instanceof PaymentEntity) { //해당조건에 맞는게 없으면 생성
            log_message('error', sprintf(
                "\n------Last Query (%s)-----\nQuery: %s\n------------------------------\n",
                static::class . '->' . __FUNCTION__,
                $this->model->getLastQuery() ?? "No Query Available",
            ));
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 기존 서비스정보의 {$oldServiceEntity->getTitle()}에 해당하는 결제정보가 존재하지 않습니다.");
        }
        //신규 서비스정보에 맞게 수정
        $formDatas = $this->getFormDatasFromService($serviceEntity);
        $entity = parent::modify_process($entity, $formDatas);
        return $entity;
    }
    //서버파트별 일회성 관련
    private function getFormDatasFromServerPart(ServerPartEntity $serverPartEntity, array $formDatas = []): array
    {
        if ($serverPartEntity->getServiceInfoUid() === null) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 서비스정보가 정의되지 않아 일회성 상품을 설정하실수 없습니다.");
        }
        $formDatas['serviceinfo_uid'] = $serverPartEntity->getServiceInfoUid();
        $formDatas["clientinfo_uid"] = $serverPartEntity->getClientInfoUid();
        $formDatas["serverpartinfo_uid"] = $serverPartEntity->getPK();
        $formDatas['amount']          = $serverPartEntity->getAmount();
        $formDatas['billing']         = $formDatas['billing'] ?? PAYMENT['BILLING']['ONETIME'];
        $formDatas['billing_at']      = $serverPartEntity->getBillingAt();
        $formDatas['pay']             = $formDatas['pay'] ?? PAYMENT['PAY']['ACCOUNT'];
        $formDatas['status']          = $formDatas['status'] ?? STATUS['UNPAID'];
        $formDatas['title']         = sprintf("%s 일회성비용", $formDatas['title'] ?? $serverPartEntity->getCustomTitle());
        return $formDatas;
    }
    public function createByServerPart(ServerPartEntity $serverPartEntity): PaymentEntity
    {
        if ($serverPartEntity->getServiceInfoUid() === null) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 서비스정보가 정의되지 않아 일회성 상품을 설정하실수 없습니다.");
        }
        $formDatas = $this->getFormDatasFromServerPart($serverPartEntity);
        return parent::create_process($formDatas);
    }
    public function modifyByServerPart(ServerPartEntity $oldServerPartEntity, ServerPartEntity $serverPartEntity): PaymentEntity
    {
        if ($serverPartEntity->getServiceInfoUid() === null) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 서비스정보가 정의되지 않아 일회성 상품을 설정하실수 없습니다.");
        }
        //서버파트정보의 서비스번호가 같고, 청구방식이 onetime이고 상태가 UNPAID인 결제정보 가져와서 결제정보 수정
        $entity = $this->getEntity([
            'serverpartinfo_uid' => $oldServerPartEntity->getPK(),
            'serviceinfo_uid' => $oldServerPartEntity->getServiceInfoUid(),
            'billing' => $oldServerPartEntity->getBilling(),
            'billing_at' => $oldServerPartEntity->getBillingAt(),
            'status' =>  STATUS['UNPAID']
        ]);
        if (!$entity instanceof PaymentEntity) { //해당조건에 맞는게 없으면 생성
            log_message('error', sprintf(
                "\n------Last Query (%s)-----\nQuery: %s\n------------------------------\n",
                static::class . '->' . __FUNCTION__,
                $this->model->getLastQuery() ?? "No Query Available",
            ));
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 오류발생: 기존 서버파트정보의 {$oldServerPartEntity->getTitle()}에 해당하는 결제정보가 존재하지 않습니다.");
        }
        $formDatas = $this->getFormDatasFromServerPart($serverPartEntity);
        $entity = parent::modify_process($entity, $formDatas);
        return $entity;
    }
}
